/*
 * Copyright (c) 2016, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *    * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *    * Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 *    * Neither the name of The Linux Foundation nor the names of its
 *      contributors may be used to endorse or promote products derived
 *      from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"

/* Platform includes. */
#include "ctypes.h"
#include "debug.h"
#include "errno.h"
#include "io.h"

#include <soc_clkc.h>
#include <soc_pmu.h>

#define ARRAY_SIZE(arr) (sizeof(arr) / sizeof((arr)[0]))

struct rate_reg_values_t {
	unsigned int rate;
	u32 value;
};

static const struct rate_reg_values_t rate_dac_reg_values[] = {
	{32000, DAC_BASE_SMAPLE_RATE_32K0},
	{44100, DAC_BASE_SMAPLE_RATE_44K1},
	{48000, DAC_BASE_SMAPLE_RATE_48K0},
	{96000, DAC_BASE_SMAPLE_RATE_96K0},
	{192000, DAC_BASE_SMAPLE_RATE_192K0},
};

static const struct rate_reg_values_t rate_adc_reg_values[] = {
	{8000, ADC_SAMPLE_RATE_08K},
	{11025, ADC_SAMPLE_RATE_11K},
	{16000, ADC_SAMPLE_RATE_16K},
	{22050, ADC_SAMPLE_RATE_22K},
	{32000, ADC_SAMPLE_RATE_32K},
	{44100, ADC_SAMPLE_RATE_44K},
	{48000, ADC_SAMPLE_RATE_48K},
	{96000, ADC_SAMPLE_RATE_96K},
};

static u32 rate_to_reg(int playback, int rate)
{
	int i;

	if (playback) {
		for (i = 0; i < ARRAY_SIZE(rate_dac_reg_values); i++) {
			if (rate_dac_reg_values[i].rate == rate)
				return KCODEC_DAC_SELECT_EXT
					| rate_dac_reg_values[i].value
					<< KCODEC_DAC_EXT_BASE_SAMP_RATE_SHIFT;
		}
	} else {
		for (i = 0; i < ARRAY_SIZE(rate_adc_reg_values); i++) {
			if (rate_adc_reg_values[i].rate == rate)
				return rate_adc_reg_values[i].value;
		}
	}
	return 0;
}

static const u32 dac_sample_rate_regs[] = {
	A7DA_PMU_KCODEC_DAC_A_SAMP_RATE,
	A7DA_PMU_KCODEC_DAC_B_SAMP_RATE,
	A7DA_PMU_KCODEC_DAC_C_SAMP_RATE,
	A7DA_PMU_KCODEC_DAC_D_SAMP_RATE
};

static const u32 dac_gain_regs[] = {
	A7DA_PMU_KCODEC_DAC_A_GAIN,
	A7DA_PMU_KCODEC_DAC_B_GAIN,
	A7DA_PMU_KCODEC_DAC_C_GAIN,
	A7DA_PMU_KCODEC_DAC_D_GAIN
};

static const u32 adc_gain_regs[] = {
	A7DA_PMU_KCODEC_ADC_A_GAIN,
	A7DA_PMU_KCODEC_ADC_B_GAIN
};

void atlas7_codec_start(int playback, int channels,
						u32 input_path, int sample_rate)
{
	int i;

	if (playback) {
		/* DACx config */
		REG_UPDATE_BITS(A7DA_PMU_AUDIO_KCODEC_CTRL, KCODEC_DAC_EN,
				KCODEC_DAC_EN);
		REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG, 1 << 12, 1 << 12);
		if (channels == 4) {
			REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG, 1 << 13, 1 << 13);
			REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG2, 1 << 12, 1 << 12);
			REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG2, 1 << 13, 1 << 13);
		}

		/* Sample rate */
		for (i = 0; i < channels; i++) {
			REG_UPDATE_BITS(dac_gain_regs[i], AUDIO_GAIN_MASK, 32);
			SOC_REG(dac_sample_rate_regs[i]) = rate_to_reg(playback,
															sample_rate);
		}
	} else {
		/* ADCx */
		REG_UPDATE_BITS(A7DA_PMU_AUDIO_KCODEC_CTRL, KCODEC_ADC_EN,
				KCODEC_ADC_EN);
		for (i = 0; i < channels; i++)
			REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG, 1 << (10 + i),
					1 << (10 + i));

		switch (input_path) {
		case 1: /* One Mic input */
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL2,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK,
				AUDIO_ANA_ADC_MICAMP_GAIN);
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL3,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK, 0x0000);
			SOC_REG(A7DA_PMU_AUDIO_ANA_ADC_CTRL0) = 0x1080;
			break;
		case 2: /* Two Mic input */
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL2,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK,
				AUDIO_ANA_ADC_MICAMP_GAIN);
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL3,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK,
				AUDIO_ANA_ADC_MICAMP_GAIN);
			SOC_REG(A7DA_PMU_AUDIO_ANA_ADC_CTRL0) = 0x10C1;
			break;
		case 3: /* Line0In input */
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL2,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK, 0x0000);
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL3,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK, 0x0000);
			SOC_REG(A7DA_PMU_AUDIO_ANA_ADC_CTRL0) = 0x1850;
			break;
		case 4: /* Line1In input */
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL2,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK, 0x0000);
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL3,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK, 0x0000);
			SOC_REG(A7DA_PMU_AUDIO_ANA_ADC_CTRL0) = 0x1448;
			break;
		case 5: /* Line2In input */
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL2,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK, 0x0000);
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL3,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK, 0x0000);
			SOC_REG(A7DA_PMU_AUDIO_ANA_ADC_CTRL0) = 0x1244;
			break;
		case 6: /* Line3In input */
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL2,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK, 0x0000);
			REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL3,
				AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK, 0x0000);
			SOC_REG(A7DA_PMU_AUDIO_ANA_ADC_CTRL0) = 0x1142;
			break;
		default:
			SOC_REG(A7DA_PMU_AUDIO_ANA_ADC_CTRL0) = 0x0000;
			break;
		}

		/* Sample rate */
		for (i = 0; i < channels; i++) {
			REG_UPDATE_BITS(adc_gain_regs[i], AUDIO_GAIN_MASK, 32);
			SOC_REG(A7DA_PMU_KCODEC_ADC_A_SAMP_RATE + (i * 0x20)) =
					rate_to_reg(playback, sample_rate);
		}
	}
}

void atlas7_codec_stop(int playback)
{
	int i;

	if (playback) {
		REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG, 1 << 12, 0);
		REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG, 1 << 13, 0);
		REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG2, 1 << 12, 0);
		REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG2, 1 << 13, 0);
		REG_UPDATE_BITS(A7DA_PMU_AUDIO_KCODEC_CTRL, KCODEC_DAC_EN, 0);
	} else {
		SOC_REG(A7DA_PMU_AUDIO_ANA_ADC_CTRL0) = 0x0000;
		REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL2,
			AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK, 0x0000);
		REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL3,
			AUDIO_ANA_ADC_MICAMP_GAIN_SEL_MASK, 0x0000);

		for (i = 0; i < 2; i++)
				REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG,
					1 << (10 + i), 0);
		REG_UPDATE_BITS(A7DA_PMU_AUDIO_KCODEC_CTRL, KCODEC_ADC_EN, 0);
	}
}

static void atlas7_codec_pre_init_adc(void)
{
	REG_UPDATE_BITS(A7DA_PMU_ANA_PMUCTL2,  PMUCTRL2_VBG_TRIM_MASK, 0xf);

	/* Workaround for some registers update fail. */
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_CTRL_SPARE_0,
			ANA_MACRO_CLK_TEST_SEL_MASK,
			2 << ANA_MACRO_CLK_TEST_SEL_SHIFT);

	/* Workaround for some registers update fail. */
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_CTRL_SPARE_0,
		ANA_MACRO_CLK_TEST_SEL_MASK,
		(2 << ANA_MACRO_CLK_TEST_SEL_SHIFT));
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_DIGMIC_CTRL,
		ANA_DIG_MIC_CLK_TEST_EN_MASK,
		(1 << ANA_DIG_MIC_CLK_TEST_EN_SHIFT));
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_DIGMIC_CTRL,
		ANA_DIG_MIC_CLK_TEST_EN_MASK, 0);
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_CTRL_SPARE_0,
		ANA_MACRO_CLK_TEST_SEL_MASK, 0);

	REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_REF_CTRL0,
		AUDIO_ANA_REF_AUDBIAS_IREF_EN |
		AUDIO_ANA_REF_AUDBIAS_VAG_RX_EN |
		AUDIO_ANA_REF_AUDBIAS_VAG_TX_EN |
		AUDIO_ANA_REF_VGA_IREF_TX_EN |
		AUDIO_ANA_REF_AUDBIAS_IREF_TRIM |
		AUDIO_ANA_REF_AUDBIAS_VAG_TSADC_EN,
		AUDIO_ANA_REF_AUDBIAS_IREF_EN |
		AUDIO_ANA_REF_AUDBIAS_VAG_RX_EN |
		AUDIO_ANA_REF_AUDBIAS_VAG_TX_EN |
		AUDIO_ANA_REF_VGA_IREF_TX_EN |
		AUDIO_ANA_REF_AUDBIAS_IREF_TRIM |
		AUDIO_ANA_REF_AUDBIAS_VAG_TSADC_EN);

	REG_UPDATE_BITS(A7DA_PMU_AUDIO_REGS_CLK_CTRL,
		DAC_CLK_EN | ADC_CLK_EN,
		DAC_CLK_EN | ADC_CLK_EN);
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_DAC_CTRL0,
		AUDIO_ANA_DAC_VGEN_EN_MASK | AUDIO_ANA_DAC_LOUT_EN_MASK |
		AUDIO_ANA_DAC_BUF_LOUT_EN_MASK,
		(1 << AUDIO_ANA_DAC_VGEN_EN_SHIFT) |
		(0xf << AUDIO_ANA_DAC_LOUT_EN_SHIFT) |
		(0xf << AUDIO_ANA_DAC_BUF_LOUT_EN_SHIFT));

	REG_UPDATE_BITS(A7DA_PMU_KCODEC_DAC_A_GAIN,
		KCODEC_DAC_GAIN_SELECT_FINE, KCODEC_DAC_GAIN_SELECT_FINE);
	REG_UPDATE_BITS(A7DA_PMU_KCODEC_DAC_B_GAIN,
		KCODEC_DAC_GAIN_SELECT_FINE, KCODEC_DAC_GAIN_SELECT_FINE);
	REG_UPDATE_BITS(A7DA_PMU_KCODEC_DAC_C_GAIN,
		KCODEC_DAC_GAIN_SELECT_FINE, KCODEC_DAC_GAIN_SELECT_FINE);
	REG_UPDATE_BITS(A7DA_PMU_KCODEC_DAC_D_GAIN,
		KCODEC_DAC_GAIN_SELECT_FINE, KCODEC_DAC_GAIN_SELECT_FINE);

	REG_UPDATE_BITS(A7DA_PMU_KCODEC_ADC_A_GAIN,
		KCODEC_ADC_GAIN_SELECT_FINE, KCODEC_ADC_GAIN_SELECT_FINE);
	REG_UPDATE_BITS(A7DA_PMU_KCODEC_ADC_B_GAIN,
		KCODEC_ADC_GAIN_SELECT_FINE, KCODEC_ADC_GAIN_SELECT_FINE);

	REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG,
		KCODEC_CONFIG_DSM_DITHER_EN_MASK, 0);
	REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG_EXTENSION2,
		KCODEC_CONFIG_DEM_DITHER_CFG_MASK,
		(0x1f << KCODEC_CONFIG_DEM_DITHER_CFG_SHIFT));
	REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG2,
		KCODEC_CONFIG_DSM_DITHER_EN_MASK, 0);
	REG_UPDATE_BITS(A7DA_PMU_KCODEC_CONFIG2_EXTENSION2,
		KCODEC_CONFIG_DEM_DITHER_CFG_MASK,
		(0x1f << KCODEC_CONFIG_DEM_DITHER_CFG_SHIFT));

	/* DAC reset */
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_DAC_CTRL,
		DAC_RESET_MASK, 0);

	/* ADC CH1 */
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL2,
		AUDIO_ANA_ADC_CHANNEL_EN | AUDIO_ANA_ADC_CHANNEL_DITHER_EN |
		AUDIO_ANA_ADC_CHANNEL_DWA_EN,
		AUDIO_ANA_ADC_CHANNEL_EN | AUDIO_ANA_ADC_CHANNEL_DITHER_EN |
		AUDIO_ANA_ADC_CHANNEL_DWA_EN);
	/* ADC CH2 */
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL3,
		AUDIO_ANA_ADC_CHANNEL_EN | AUDIO_ANA_ADC_CHANNEL_DITHER_EN |
		AUDIO_ANA_ADC_CHANNEL_DWA_EN,
		AUDIO_ANA_ADC_CHANNEL_EN | AUDIO_ANA_ADC_CHANNEL_DITHER_EN |
		AUDIO_ANA_ADC_CHANNEL_DWA_EN);

	REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL2,
		AUDIO_ANA_ADC_CHANNEL_GAIN_SEL_MASK,
		(0xA << AUDIO_ANA_ADC_CHANNEL_GAIN_SEL_SHIFT));
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL3,
		AUDIO_ANA_ADC_CHANNEL_GAIN_SEL_MASK,
		(0xA << AUDIO_ANA_ADC_CHANNEL_GAIN_SEL_SHIFT));
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL3,
		AUDIO_ANA_ADC_CHANNEL_CLK_SEL_DELAY_MASK,
		(0x8 << AUDIO_ANA_ADC_CHANNEL_CLK_SEL_DELAY_SHIFT));
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL2,
		AUDIO_ANA_ADC_CHANNEL_CLK_SEL_DELAY_MASK,
		(0x8 << AUDIO_ANA_ADC_CHANNEL_CLK_SEL_DELAY_SHIFT));

	/* ADC reset */
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_CAL_CTRL0,
		AUDIO_ANA_CAL_ADC_EN, 0);
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_REGS_CLK_CTRL,
		AUDIO_ANA_CAL_CLK_EN, AUDIO_ANA_CAL_CLK_EN);
	REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_CAL_CTRL0,
		AUDIO_ANA_CAL_ADC_EN, AUDIO_ANA_CAL_ADC_EN);

	REG_UPDATE_BITS(A7DA_PMU_AUDIO_ANA_ADC_CTRL1,
		AUDIO_ANA_ADC_CH12_CCAL_SEL_MASK,
		(6 << AUDIO_ANA_ADC_CH12_CCAL_SEL_SHIFT));
}

void atlas7_codec_setup(void)
{
	/* Enable PMU audio regulator */
	pmu_audio_regulator_enable();
	pmu_clk_enable();
	atlas7_codec_pre_init_adc();
}
